#include "vregist.h"

/* Implementation der Funktionen */


VREGIST::VREGIST()
{
  view=(VIEW *) malloc(sizeof(VIEW));
  nvis=0; t_1=0; t_2=0; ts_1=0; ts_2=0; tm_1=-1; tm_2=-1;
}

VREGIST::~VREGIST()
{
  free(view);
}

void VREGIST::alloc_view(short nch) {view=(VIEW *)realloc(view, nch*sizeof(VIEW));}

int  VREGIST::DelChannel(short nch) {
  int           rc=0;
  short         i;
  unsigned long ni;
  
  if ((nch>=n) || (nch<0))  {
    rc=-1;
    goto ende;
  }
  
  if(view[nch].is_visible) nvis--;
  for (i=nch+1; i<n; i++) {
    ch[i-1].data=(float *)realloc(ch[i-1].data, ch[i].n * sizeof(float));
    for (ni=0; ni<ch[i].n; ni++) ch[i-1].data[ni]=ch[i].data[ni];
    ch[i-1].n=ch[i].n;
    ch[i-1].sr=ch[i].sr;
    ch[i-1].min=ch[i].min;
    ch[i-1].max=ch[i].max;
    ch[i-1].color=ch[i].color;
    ch[i-1].height=ch[i].height;
    strcpy(ch[i-1].name, ch[i].name);
    strcpy(ch[i-1].unit, ch[i].unit);
    view[i-1].is_active=view[i].is_active;
    view[i-1].is_frequency=view[i].is_frequency;
    view[i-1].is_visible=view[i].is_visible;
    view[i-1].min=view[i].min;
    view[i-1].max=view[i].max;
    strcpy(view[i-1].from_file, view[i].from_file);
  }

  n--;
  free(ch[n].data);
  ch=(CHANNEL *) realloc(ch, n*sizeof(CHANNEL));
  view=(VIEW *) realloc(view, n*sizeof(VIEW));
  /* delete comments if no channels are left */
  if(n==0) {
    if (comments->n>0)
      for (ni=0; ni<comments->n; ni++) free((char *)comments->comment[ni]);
    comments->n=0;
  }

 ende:
  return rc;
}

int VREGIST::AddChannel(unsigned long ndata,
			float sr=1, float min=0, float max=1,
			int height=0, int color=0,
			char *name="channel", char *unit="unit") {
  int rc=0;
  
  n++;
  ch=(CHANNEL *) realloc(ch,n*sizeof(CHANNEL));
  ch[n-1].data=(float *) malloc(ndata*sizeof(float));
  ch[n-1].n=ndata;
  ch[n-1].sr=sr;
  ch[n-1].min=min;
  ch[n-1].max=max;
  ch[n-1].height=height;
  ch[n-1].color=color;
  strcpy(ch[n-1].name, name);
  strcpy(ch[n-1].unit, unit);
  alloc_view(n);
  nvis++;
  view[n-1].is_active=0; view[n-1].is_visible=1; view[n-1].is_frequency=0;
  view[n-1].min=min; view[n-1].max=max;
  strcpy(view[n-1].from_file, "calculated");
  return rc;
}

